# AWK script to get the dominant species for each grid cell from an input file.
# See the dominance shell script for more documentation.

# Initialize some variables
BEGIN {
   lat = -1;
   lon = -1;
   total = -1;
}

# Handle the title row
# Here we should prepare and print the title for the output, and find the
# column numbers for lat, lon and total.
NF>0 && $1 != $1+0 {
   title = "";
   for (i=1; i <= NF; i++) {
      # Remember the name of each column for later use
      name_of_column[i] = $i
      if ($i == "Lat") {
         lat = i;
         title=title"        Lat"
      }
      else if ($i == "Lon") {
         lon = i;
         title=title"        Lon"
      }
      else if ($i == "Total") {
         total = i;
      }
   }
   print title"       Pft#            Name             Max";
}

# Handle rows with numbers
NF>0 && $1 == $1+0 {
   if (lat != -1 && lon != -1 && total != -1) {
      max_val=0
      max_pft=0
      max_name=""
      first=1
      current_pft=0

      for (i=1; i <= NF; i++) {
         if (i != lat && i != lon && i != total) {
            # This column is a pft column
            current_pft++
            if (first == 1 || $i > max_val) {
               max_val = $i
               max_pft = current_pft
               max_name=name_of_column[i]
               first = 0
            }
         }
         else if (i == lat || i == lon) {
            printf " %10s",$i
         }
      }

      if (max_val == 0) {
         max_name = "NO_VEG"
         max_pft = current_pft+1
      }
      printf " %10s %15s %15s\n",max_pft,max_name,max_val
   }
}

# If we never found a title, print a warning
END {
   if (lat == -1 || lon == -1 || total == -1) {
      print "Missing title in input!"
   }
}
